import {AfterViewInit, Component, Input} from '@angular/core'
import {Recipe} from '../../../shared/model/recipe.model'

@Component({
  selector: 'cre-recipe-info',
  templateUrl: './recipe-info.component.html',
  styleUrls: ['./recipe-info.component.sass']
})
export class RecipeInfoComponent implements AfterViewInit {
  @Input() recipe: Recipe
  @Input() hasModifications: boolean

  isBPacExtensionInstalled = false

  ngAfterViewInit(): void {

    this.isBPacExtensionInstalled = document.querySelectorAll('.bpac-extension-installed').length > 0
  }

  get darkColor(): boolean {
    // https://stackoverflow.com/questions/12043187/how-to-check-if-hex-color-is-too-black
    const c = this.recipe.color.substring(1)      // strip #
    const rgb = parseInt(c, 16)   // convert rrggbb to decimal
    const r = (rgb >> 16) & 0xff  // extract red
    const g = (rgb >> 8) & 0xff  // extract green
    const b = (rgb >> 0) & 0xff  // extract blue

    const luma = 0.2126 * r + 0.7152 * g + 0.0722 * b // per ITU-R BT.709
    return luma < 100
  }
}
